/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * DlgArrow.h
 *  Created on: 17.10.2009
 */

#ifndef DLGARROW_H_
#define DLGARROW_H_

#include <QDialog>
#include "Pfeil.h"
#include "DlgArrowTabUpdateable.h"
#include "DlgArrowModel.h"
#include <QTabWidget>
#include <QStackedWidget>
#include <QList>
#include "UnitConverter.h"
#include <QRadioButton>

class DlgArrowModel;


class DlgArrow: public QDialog {
Q_OBJECT
public:


	DlgArrow(QWidget * parent = 0, Qt::WFlags f = 0);

	void init(CPfeil &p, UnitConverter& unitconv);
	CPfeil m_arrow;
	UnitConverter m_unitconverter;
	QStackedWidget *mModelDlg;
	//DlgArrowModel *m_simplified;
	QPushButton *mAccept;
	QPushButton *mCancel;
	QLineEdit *mName;

	QButtonGroup *mModel;
	QRadioButton *mModelFullArrow;
	QRadioButton *mModelSimplifiedArrow;


public slots:
	void accept();
	void on_mModelFullArrow_toggled ( bool checked );
	void on_mModelSimplifiedArrow_toggled ( bool checked );

protected:
};

#endif /* DLGARROW_H_ */
