/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * DlgArrowModel.h
 *  Created on: 01.05.2010
 */

#ifndef DLGARROWMODEL_H_
#define DLGARROWMODEL_H_

#include <QtGui/QWidget>

#include "Pfeil.h"
#include "DlgArrowTabUpdateable.h"

#include <QTabWidget>
#include <QList>
#include "UnitConverter.h"

class DlgArrowTabUpdateable;

class DlgArrowModel : public QWidget {
	Q_OBJECT

public:
	enum Statusflag {
		defaultvalue = 0,
		modified_by_user = 1 ,
		calculated = 2

	};

	DlgArrowModel();
	virtual ~DlgArrowModel();

	void init(CPfeil *p, UnitConverter& unitconv);
	CPfeil *m_parrow;
	UnitConverter m_unitconverter;
	QTabWidget *m_tab;

	void slotUpdateAllViews(DlgArrowTabUpdateable *sender);

	QList<DlgArrowTabUpdateable*> *m_pViewList;




};

#endif /* DLGARROWMODEL_H_ */
