/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * settingcurve.cpp
 *  Created on: 16.08.2009
 */

#include "akima_curve.h"
#include "aspline.h"

akima_curve::akima_curve() {
	err = false;

}

akima_curve::~akima_curve() {
	// TODO Auto-generated destructor stub
}
int akima_curve::insertpoint(double x, utility::vector_3d y)
{
	spline_x.insertpoint(x, y.x);
	spline_y.insertpoint(x, y.y);
	spline_z.insertpoint(x, y.z);
	if(spline_x.err || spline_y.err || spline_z.err)
	{
		err = true;
		return 1;
	}
		return 0;
}
int akima_curve::calcspline()
{
	spline_x.calcspline();
	spline_y.calcspline();
	spline_z.calcspline();
	if(spline_x.err || spline_y.err || spline_z.err)
	{
		err = true;
		return 1;
	}
	return 0;

}
int akima_curve::spline(utility::vector_3d &y, double x)
{
	spline_x.spline(y.x, x);
	spline_y.spline(y.y, x);
	spline_z.spline(y.z, x);
	if(spline_x.err || spline_y.err || spline_z.err)
	{
		err = true;
		return 1;
	}
	return 0;

}
void akima_curve::clear()
{
	spline_x.clear();
	spline_y.clear();
	spline_z.clear();

}
