/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ARROWMATCHER_FILE_H
#define ARROWMATCHER_FILE_H

#include <QDomDocument>
#include "arrowmatcherdoc.h"
#include <QMap>
#include <QVariant>
// for the friend declaration in arrowmatcherdoc
class ArrowmatcherDoc;
/**
@author Herbert Roider
*/
class arrowmatcher_file{
public:
    arrowmatcher_file();

    ~arrowmatcher_file();
    int read(QIODevice *device, ArrowmatcherDoc *doc);
    int write(QIODevice *device, ArrowmatcherDoc *doc);
    //int readCrossbow(CArmbrust & a, const QDomElement &element);
    //int readArrow(CPfeil & a, const QDomElement &dom_arrow);
    //int writeCrossbow(QDomElement &dom_arrow, QDomDocument &domDocument,  CArmbrust & a);
    //int writeArrow(QDomElement &dom_arrow, QDomDocument &domDocument, CPfeil & a);
    int read_vector(utility::vector_3d &v, const QDomElement &dom_vector );
    int write_vector(QDomElement &dom_vector, QDomDocument &domDocument, const utility::vector_3d & v);
    //int readSight(CZielgeraet &s , const QDomElement &dom_sight );
    //int writeSight(QDomElement &dom_sight, QDomDocument &domDocument, const CZielgeraet & s);
    int writeMap(QDomElement &dom_map, QDomDocument &domDocument, const QMap<QString, QVariant> &v);
    int readMap(QMap<QString, QVariant> &v, const QDomElement &dom_map);

};

#endif
