/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 *
 *  Created on: 26.10.2009
 */

#include "dlgarrowtabmain.h"

DlgArrowTabMain::DlgArrowTabMain(QWidget *parent) :
	QWidget(parent) {
	ui.setupUi(this);
	m_pArrow = 0;

}

DlgArrowTabMain::~DlgArrowTabMain() {

}
void DlgArrowTabMain::update(CPfeil *arrow) {
	//std::cout << "DlgArrowTabMain::update" << endl;
	this->blockSignals(true);
	m_pArrow = arrow;

	//////////////////////
	ui.txtFF_Frontal->setText(
			m_pArrow->m_data.value("txtFF_Frontal").toMap().value("value").toString());
	ui.txtFF_Cross->setText(
			m_pArrow->m_data.value("txtFF_Cross").toMap().value("value").toString());
	ui.txtAreaFrontal->setText(
			m_pArrow->m_data.value("txtAreaFrontal").toMap().value("value").toString());
	ui.txtAreaCrossSection->setText(m_pArrow->m_data.value(
			"txtAreaCrossSection").toMap().value("value").toString());
	ui.txtCenterOfPresure->setText(
			m_pArrow->m_data.value("txtCenterOfPresure").toMap().value("value").toString());
	ui.txtMomentOfInertia->setText(
			m_pArrow->m_data.value("txtMomentOfInertia").toMap().value("value").toString());
	ui.txtMass->setText(
			m_pArrow->m_data.value("txtMass").toMap().value("value").toString());


	////////////////////////////////////
	// Hide unused input fields, depends on the Model
	if(m_pArrow->getValue("txtFF_Frontal/hidden") == 1) {
		ui.txtFF_Frontal->setEnabled(false);
	} else {
		ui.txtFF_Frontal->setEnabled(true);
	}

	if(m_pArrow->getValue("txtFF_Cross/hidden") == 1) {
		ui.txtFF_Cross->setEnabled(false);
	} else {
		ui.txtFF_Cross->setEnabled(true);
	}

	if(m_pArrow->getValue("txtAreaFrontal/hidden") == 1) {
		ui.txtAreaFrontal->setEnabled(false);
		ui.cboAreaFrontal->setEnabled(false);
	} else {
		ui.txtAreaFrontal->setEnabled(true);
		ui.cboAreaFrontal->setEnabled(true);
	}

	if(m_pArrow->getValue("txtAreaCrossSection/hidden") == 1) {
		ui.txtAreaCrossSection->setEnabled(false);
		ui.cboAreaCrossSection->setEnabled(false);
	} else {
		ui.txtAreaCrossSection->setEnabled(true);
		ui.cboAreaCrossSection->setEnabled(true);
	}

	if(m_pArrow->getValue("txtCenterOfPresure/hidden") == 1) {
		ui.txtCenterOfPresure->setEnabled(false);
		ui.cboCenterOfPresure->setEnabled(false);
	} else {
		ui.txtCenterOfPresure->setEnabled(true);
		ui.cboCenterOfPresure->setEnabled(true);
	}

	if(m_pArrow->getValue("txtMomentOfInertia/hidden") == 1) {
		ui.txtMomentOfInertia->setEnabled(false);
		ui.cboMomentOfInertia->setEnabled(false);
	} else {
		ui.txtMomentOfInertia->setEnabled(true);
		ui.cboMomentOfInertia->setEnabled(true);
	}

	if(m_pArrow->getValue("txtMass/hidden") == 1) {
		ui.txtMass->setEnabled(false);
		ui.cboMass->setEnabled(false);
	} else {
		ui.txtMass->setEnabled(true);
		ui.cboMass->setEnabled(true);
	}






	////////////////////
	QString style_calculated = "QLineEdit {color: rgb(0, 150, 0);}";
	QString style_default = "QLineEdit {color: rgb(0, 0, 150);}";

	switch (m_pArrow->m_data["txtFF_Frontal"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtFF_Frontal->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtFF_Frontal->setStyleSheet(style_default);
		break;
	default:
		ui.txtFF_Frontal->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtFF_Cross"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtFF_Cross->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtFF_Cross->setStyleSheet(style_default);
		break;
	default:
		ui.txtFF_Cross->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtAreaFrontal"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtAreaFrontal->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtAreaFrontal->setStyleSheet(style_default);
		break;
	default:
		ui.txtAreaFrontal->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtAreaCrossSection"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtAreaCrossSection->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtAreaCrossSection->setStyleSheet(style_default);
		break;
	default:
		ui.txtAreaCrossSection->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtCenterOfPresure"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtCenterOfPresure->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtCenterOfPresure->setStyleSheet(style_default);
		break;
	default:
		ui.txtCenterOfPresure->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtMomentOfInertia"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtMomentOfInertia->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtMomentOfInertia->setStyleSheet(style_default);
		break;
	default:
		ui.txtMomentOfInertia->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtMass"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtMass->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtMass->setStyleSheet(style_default);
		break;
	default:
		ui.txtMass->setStyleSheet("");
	}

	///////////////////////////////
	// Units for Comboboxes
	this->set_unit_id(
			m_pArrow->m_data["txtAreaCrossSection"].toMap()["unit"].toString(),
			ui.cboAreaCrossSection);
	this->set_unit_id(
			m_pArrow->m_data["txtAreaFrontal"].toMap()["unit"].toString(),
			ui.cboAreaFrontal);
	this->set_unit_id(
			m_pArrow->m_data["txtCenterOfPresure"].toMap()["unit"].toString(),
			ui.cboCenterOfPresure);
	this->set_unit_id(
			m_pArrow->m_data["txtMomentOfInertia"].toMap()["unit"].toString(),
			ui.cboMomentOfInertia);
	this->set_unit_id(m_pArrow->m_data["txtMass"].toMap()["unit"].toString(),
			ui.cboMass);

	////////////////
	// values for the textfields
	QString unit_id;

	m_pArrow->A_frontal
			= m_pArrow->m_data.value("txtAreaFrontal").toMap().value("value").toDouble();
	unit_id = m_pArrow->m_data["txtAreaFrontal"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->A_frontal, unit_id);

	m_pArrow->A_cross
			= m_pArrow->m_data.value("txtAreaCrossSection").toMap().value(
					"value").toDouble();
	unit_id
			= m_pArrow->m_data["txtAreaCrossSection"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->A_cross, unit_id);

	m_pArrow->ff_frontal
			= m_pArrow->m_data.value("txtFF_Frontal").toMap().value("value").toDouble();
	unit_id = m_pArrow->m_data["txtFF_Frontal"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->ff_frontal, unit_id);

	m_pArrow->ff_cross = m_pArrow->m_data.value("txtFF_Cross").toMap().value(
			"value").toDouble();
	unit_id = m_pArrow->m_data["txtFF_Cross"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->ff_cross, unit_id);

	m_pArrow->cp = m_pArrow->m_data.value("txtCenterOfPresure").toMap().value(
			"value").toDouble();
	unit_id = m_pArrow->m_data["txtCenterOfPresure"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->cp, unit_id);

	m_pArrow->J = m_pArrow->m_data.value("txtMomentOfInertia").toMap().value(
			"value").toDouble();
	unit_id = m_pArrow->m_data["txtMomentOfInertia"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->J, unit_id);

	m_pArrow->m
			= m_pArrow->m_data.value("txtMass").toMap().value("value").toDouble();
	unit_id = m_pArrow->m_data["txtMass"].toMap()["unit"].toString();
	m_pControler->m_unitconverter.convert_to_SI(m_pArrow->m, unit_id);
	this->blockSignals(false);

}
void DlgArrowTabMain::calc(CPfeil *arrow) {
	this->blockSignals(true);
	//std::cout << "DlgArrowTabMain::update" << endl;
	m_pArrow = arrow;
//	if (!m_pArrow->m_data.contains("txtFF_Frontal")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["title"] = tr("formfactor frontal");
//		m_pArrow->m_data["txtFF_Frontal"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtFF_Cross")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["title"] = tr("Fromfactor sidewise");
//		m_pArrow->m_data["txtFF_Cross"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtAreaFrontal")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["unit"] = "SI_square_metre";
//		map["title"] = tr("frontal area");
//		m_pArrow->m_data["txtAreaFrontal"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtAreaCrossSection")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["unit"] = "SI_square_metre";
//		map["title"] = tr("cross section area");
//		m_pArrow->m_data["txtAreaCrossSection"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtCenterOfPresure")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["unit"] = "SI_metre";
//		map["title"] = tr("center of presure");
//		m_pArrow->m_data["txtCenterOfPresure"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtMomentOfInertia")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["unit"] = "SI_kilogram_square_metre";
//		map["title"] = tr("moment of inertia");
//		m_pArrow->m_data["txtMomentOfInertia"] = map;
//	}
//	if (!m_pArrow->m_data.contains("txtMass")) {
//		QMap<QString, QVariant> map;
//		map["value"] = "";
//		map["status"] = DlgArrowModel::defaultvalue;
//		map["unit"] = "SI_kilogram";
//		map["title"] = tr("mass");
//		m_pArrow->m_data["txtMass"] = map;
//	}
	///////////////////////////////////
	// Defaultvalues:
	CPfeil default_arrow; // only for the default values

	if (m_pArrow->m_data["txtFF_Frontal"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtFF_Frontal"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtFF_Frontal/value", QString::number(default_arrow.ff_frontal));
		m_pArrow->setValue("txtFF_Frontal/status", DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtFF_Cross"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtFF_Cross"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtFF_Cross/value", QString::number(default_arrow.ff_cross));
		m_pArrow->setValue("txtFF_Cross/status", DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtAreaFrontal"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtAreaFrontal"].toMap()["value"].toString().length()
					< 1

	) {
		m_pArrow->setValue("txtAreaFrontal/value", QString::number(default_arrow.A_frontal) );
		m_pArrow->setValue("txtFF_Frontal/status" ,DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtAreaCrossSection"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtAreaCrossSection"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtAreaCrossSection/value", QString::number(default_arrow.A_cross));
		m_pArrow->setValue("txtAreaCrossSection/status", DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtCenterOfPresure"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtCenterOfPresure"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtCenterOfPresure/value", QString::number(default_arrow.cp));
		m_pArrow->setValue("txtCenterOfPresure/status",  DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtMomentOfInertia"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtMomentOfInertia"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtMomentOfInertia/value", QString::number(default_arrow.J));
		m_pArrow->setValue("txtMomentOfInertia/status",  DlgArrowModel::defaultvalue);
	}
	if (m_pArrow->m_data["txtMass"].toMap().value("status").toInt()
			!= DlgArrowModel::modified_by_user
			&& m_pArrow->m_data["txtMass"].toMap()["value"].toString().length()
					< 1) {
		m_pArrow->setValue("txtMass/value", QString::number(default_arrow.m));
		m_pArrow->setValue("txtMass/status", DlgArrowModel::defaultvalue);
	}
	this->blockSignals(false);

}
void DlgArrowTabMain::addView(DlgArrowModel *dlg) {

	m_pControler = dlg;
	QList<Unit> list = m_pControler->m_unitconverter.get_units("SI_metre");
	for (int i = 0; i < list.size(); i++) {
		ui.cboCenterOfPresure->addItem(list.at(i).m_name, list.at(i).m_type_id);
	}
	list = m_pControler->m_unitconverter.get_units("SI_kilogram");
	for (int i = 0; i < list.size(); i++) {
		ui.cboMass->addItem(list.at(i).m_name, list.at(i).m_type_id);

	}
	list = m_pControler->m_unitconverter.get_units("SI_square_metre");
	for (int i = 0; i < list.size(); i++) {
		ui.cboAreaCrossSection->addItem(list.at(i).m_name, list.at(i).m_type_id);
		ui.cboAreaFrontal->addItem(list.at(i).m_name, list.at(i).m_type_id);
	}
	list = m_pControler->m_unitconverter.get_units("SI_kilogram_square_metre");
	for (int i = 0; i < list.size(); i++) {
		ui.cboMomentOfInertia->addItem(list.at(i).m_name, list.at(i).m_type_id);
	}

	QPixmap *image = new QPixmap(":/images/arrowmeasures.png");
	ui.lblImage->setPixmap(*image);

}

void DlgArrowTabMain::on_txtFF_Frontal_editingFinished() {
	if (ui.txtFF_Frontal->text()
			== m_pArrow->m_data["txtFF_Frontal"].toMap()["value"])
		return;
	if (ui.txtFF_Frontal->text().length() <= 0) {
		m_pArrow->setValue("txtFF_Frontal/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtFF_Frontal/value", "");
	} else {
		m_pArrow->setValue("txtFF_Frontal/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtFF_Frontal/value", ui.txtFF_Frontal->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtFF_Cross_editingFinished() {
	if (ui.txtFF_Cross->text()
			== m_pArrow->m_data["txtFF_Cross"].toMap()["value"])
		return;
	if (ui.txtFF_Cross->text().length() <= 0) {
		m_pArrow->setValue("txtFF_Cross/status", DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtFF_Cross/value", "");
	} else {
		m_pArrow->setValue("txtFF_Cross/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtFF_Cross/value",  ui.txtFF_Cross->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtAreaFrontal_editingFinished() {
	if (ui.txtAreaFrontal->text()
			== m_pArrow->m_data["txtAreaFrontal"].toMap()["value"])
		return;
	if (ui.txtAreaFrontal->text().length() <= 0) {
		m_pArrow->setValue("txtAreaFrontal/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtAreaFrontal/value", "");
	} else {
		m_pArrow->setValue("txtAreaFrontal/status", DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtAreaFrontal/value",  ui.txtAreaFrontal->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtAreaCrossSection_editingFinished() {
	if (ui.txtAreaCrossSection->text()
			== m_pArrow->m_data["txtAreaCrossSection"].toMap()["value"])
		return;
	if (ui.txtAreaCrossSection->text().length() <= 0) {
		m_pArrow->setValue("txtAreaCrossSection/status", DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtAreaCrossSection/value", "");
	} else {
		m_pArrow->setValue("txtAreaCrossSection/status", DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtAreaCrossSection/value", ui.txtAreaCrossSection->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtCenterOfPresure_editingFinished() {
	if (ui.txtCenterOfPresure->text()
			== m_pArrow->m_data["txtCenterOfPresure"].toMap()["value"])
		return;
	if (ui.txtCenterOfPresure->text().length() <= 0) {
		m_pArrow->setValue("txtCenterOfPresure/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtCenterOfPresure/value","");
	} else {
		m_pArrow->setValue("txtCenterOfPresure/status" ,DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtCenterOfPresure/value", ui.txtCenterOfPresure->text() );
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtMomentOfInertia_editingFinished() {
	if (ui.txtMomentOfInertia->text()
			== m_pArrow->m_data["txtMomentOfInertia"].toMap()["value"])
		return;
	if (ui.txtMomentOfInertia->text().length() <= 0) {
		m_pArrow->setValue("txtMomentOfInertia/status", DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtMomentOfInertia/value",  "");
	} else {
		m_pArrow->setValue("txtMomentOfInertia/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtMomentOfInertia/value", ui.txtMomentOfInertia->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabMain::on_txtMass_editingFinished() {
	if (ui.txtMass->text() == m_pArrow->m_data["txtMass"].toMap()["value"])
		return;
	if (ui.txtMass->text().length() <= 0) {
		m_pArrow->setValue("txtMass/status", DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtMass/value",  "");
	} else {
		m_pArrow->setValue("txtMass/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtMass/value",  ui.txtMass->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
///////////////////////////////////////
void DlgArrowTabMain::on_cboAreaFrontal_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtAreaFrontal"))
		return;
	unit_changed("txtAreaFrontal",  ui.cboAreaFrontal,index);
}
void DlgArrowTabMain::on_cboAreaCrossSection_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtAreaCrossSection"))
		return;
	unit_changed("txtAreaCrossSection", ui.cboAreaCrossSection, index);

}
void DlgArrowTabMain::on_cboCenterOfPresure_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtCenterOfPresure"))
		return;
	unit_changed("txtCenterOfPresure", ui.cboCenterOfPresure, index);

}
void DlgArrowTabMain::on_cboMass_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtMass"))
		return;
	unit_changed("txtMass",  ui.cboMass, index);

}
void DlgArrowTabMain::on_cboMomentOfInertia_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtMomentOfInertia"))
		return;
	unit_changed("txtMomentOfInertia", ui.cboMomentOfInertia, index);

}

/////////////////////////////////////////////
bool DlgArrowTabMain::get_unit_id(QString &unit_id, int index, QComboBox *combo) {
	if (index < 0)
		return false;
	unit_id = combo->itemData(index).toString();
	return true;
}
bool DlgArrowTabMain::set_unit_id(QString unit_id, QComboBox *combo) {
	QVariant var(unit_id);
	int index = combo->findData(var);
	combo->setCurrentIndex(index);
	return true;

}
bool DlgArrowTabMain::get_SI_value(double & value,
		const QMap<QString, QVariant> &map) {
	value = map["value"].toDouble();
	QString unit_id = map["unit"].toString();
	return this->m_pControler->m_unitconverter.convert_to_SI(value, unit_id);
}
bool DlgArrowTabMain::set_value_from_SI(QMap<QString, QVariant> &map,
		double value) {
	m_pControler->m_unitconverter.convert_from_SI(value, map["unit"].toString());// if conversion fails, because of an unknown unit, the SI-value is written
	map["value"] = QString::number(value);
	return true;

}
void DlgArrowTabMain::unit_changed(QMap<QString, QVariant> &map,
		QComboBox *combo, int index) {
	QString unit_id;
	if (!get_unit_id(unit_id, index, combo))
		return;
	QString prev_unit_id = map["unit"].toString();
	map["unit"] = unit_id;
	if (map["value"].toString().length() > 0) {
		double value = map["value"].toDouble();
		m_pControler->m_unitconverter.convert(value, unit_id, prev_unit_id);
		map["value"] = QString::number(value);
	}
	this->m_pControler->slotUpdateAllViews(NULL);
}
void DlgArrowTabMain::unit_changed(QString path_to_map,
		QComboBox *combo, int index) {
	QString unit_id;
	if (!get_unit_id(unit_id, index, combo))
		return;
	QString prev_unit_id = m_pArrow->getValue(path_to_map +"/unit").toString();
	m_pArrow->setValue(path_to_map + "/unit", unit_id);
	QString old_val = m_pArrow->getValue(path_to_map + "/value").toString();
	if (old_val.length() > 0) {
		double value = old_val.toDouble();
		m_pControler->m_unitconverter.convert(value, unit_id, prev_unit_id);
		m_pArrow->setValue(path_to_map + "/value",  QString::number(value) );
	}
	this->m_pControler->slotUpdateAllViews(NULL);
}

