/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 *  Created on: 28.10.2009
 */

#include "dlgarrowtabsimplified.h"

DlgArrowTabSimplified::DlgArrowTabSimplified(QWidget *parent)
    : QWidget(parent)
{
	m_pArrow = NULL;
	ui.setupUi(this);
}

DlgArrowTabSimplified::~DlgArrowTabSimplified()
{

}
void DlgArrowTabSimplified::update(CPfeil *arrow) {

	m_pArrow = arrow;

	//////////////////////
	// set values:
	ui.txtShaftdia->setText(
			m_pArrow->m_data["txtShaftdia"].toMap()["value"].toString());
	ui.txtMass->setText(
			m_pArrow->m_data["txtMass"].toMap()["value"].toString());
	ui.txtFF_Frontal->setText(
			m_pArrow->m_data["txtFF_Frontal"].toMap()["value"].toString());
	ui.txtSectionaldensity->setText(
			m_pArrow->m_data["txtSectionaldensity"].toMap()["value"].toString());
	ui.txtBallisticcoefficient->setText(
			m_pArrow->m_data["txtBallisticcoefficient"].toMap()["value"].toString());

	///////////////////////////////
	// Units for Comboboxes
	this->set_unit_id(
			m_pArrow->m_data["txtMass"].toMap()["unit"].toString(),
			ui.cboMass);
	this->set_unit_id(
			m_pArrow->m_data["txtShaftdia"].toMap()["unit"].toString(),
			ui.cboShaftdia);
	this->set_unit_id(
			m_pArrow->m_data["txtSectionaldensity"].toMap()["unit"].toString(),
			ui.cboSectionaldensity);


	////////////////////////
	// Styles:
	QString style_calculated = "QLineEdit {color: rgb(0, 150, 0);}";
	QString style_default = "QLineEdit {color: rgb(20, 50, 120);}";

	switch (m_pArrow->m_data["txtMass"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtMass->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtMass->setStyleSheet(style_default);
		break;
	default:
		ui.txtMass->setStyleSheet("");
	}


	switch (m_pArrow->m_data["txtShaftdia"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtShaftdia->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtShaftdia->setStyleSheet(style_default);
		break;
	default:
		ui.txtShaftdia->setStyleSheet("");
	}

	switch (m_pArrow->m_data["txtFF_Frontal"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtFF_Frontal->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtFF_Frontal->setStyleSheet(style_default);
		break;
	default:
		ui.txtFF_Frontal->setStyleSheet("");
	}


	switch (m_pArrow->m_data["txtSectionaldensity"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtSectionaldensity->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtSectionaldensity->setStyleSheet(style_default);
		break;
	default:
		ui.txtSectionaldensity->setStyleSheet("");
	}
	switch (m_pArrow->m_data["txtBallisticcoefficient"].toMap()["status"].toInt()) {
	case DlgArrowModel::calculated:
		ui.txtBallisticcoefficient->setStyleSheet(style_calculated);
		break;
	case DlgArrowModel::defaultvalue:
		ui.txtBallisticcoefficient->setStyleSheet(style_default);
		break;
	default:
		ui.txtBallisticcoefficient->setStyleSheet("");
	}


}


void DlgArrowTabSimplified::calc(CPfeil *arrow) {
		m_pArrow = arrow;
		//DlgArrowModel::Statusflag status = DlgArrowModel::defaultvalue;

		// Set all Values to hidden, and unhide the used values later:
		//QMap<QString, QVariant>::iterator iter ;
		//for(iter = m_pArrow->m_data.begin(); iter != m_pArrow->m_data.end(); iter++) {
		//	m_pArrow->setValue(iter.key() + "/hidden", 1);
		//}

		///////////////////////////////////
		// create the values in the map
//		if (!m_pArrow->m_data.contains("txtShaftdia")) {
//			QMap<QString, QVariant> map;
//			map["value"] = "";
//			map["status"] = DlgArrowModel::defaultvalue;
//			map["unit"] = "SI_metre";
//			map["title"] = tr("shaft diameter");
//			m_pArrow->m_data["txtShaftdia"] = map;
//		}
//		if (!m_pArrow->m_data.contains("txtMass")) {
//			QMap<QString, QVariant> map;
//			map["value"] = "";
//			map["status"] = DlgArrowModel::defaultvalue;
//			map["unit"] = "SI_kilogram";
//			map["title"] = tr("mass");
//			m_pArrow->m_data["txtMass"] = map;
//		}

		// Unhide needed values:
		//m_pArrow->setValue("txtShaftdia/hidden", 0);
		//m_pArrow->setValue("txtMass/hidden", 0);

		///////////////////////////////////
		// Defaultvalues:
		CPfeil default_arrow; // only for the default values
		QMap<QString, QVariant> map;
		if (m_pArrow->m_data["txtMass"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtMass"].toMap()["value"].toString().length()
						< 1) {
			m_pArrow->setValue("txtMass/value",  QString::number(default_arrow.m));
			m_pArrow->setValue("txtMass/status",  DlgArrowModel::defaultvalue);
		}

		if (m_pArrow->m_data["txtShaftdia"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtShaftdia"].toMap()["value"].toString().length()
						< 1) {
			double dia;
			dia = sqrt(4.0 * default_arrow.A_frontal / utility::PI);
			m_pArrow->setValue("txtShaftdia/value",  QString::number(dia));
			m_pArrow->setValue("txtShaftdia/status",  DlgArrowModel::defaultvalue);
		}
		// Set the centerofPresure to zero because we have no moment of Inertia:
		if (m_pArrow->m_data["txtCenterOfPresure"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user) {
			m_pArrow->setValue("txtCenterOfPresure/value",  QString::number(	0.0));
			m_pArrow->setValue("txtCenterOfPresure/status",  DlgArrowModel::defaultvalue);
		}
		// Set the Moment of Inertia to zero because we have no moment of Inertia:
		if (m_pArrow->m_data["txtMomentOfInertia"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user) {
			m_pArrow->setValue("txtMomentOfInertia/value",  QString::number(	0.0));
			m_pArrow->setValue("txtMomentOfInertia/status",  DlgArrowModel::defaultvalue);
		}

		if (m_pArrow->m_data["txtFF_Frontal"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtFF_Frontal"].toMap()["value"].toString().length()
						< 1) {
			m_pArrow->setValue("txtFF_Frontal/value", QString::number(default_arrow.ff_frontal));
			m_pArrow->setValue("txtFF_Frontal/status", DlgArrowModel::defaultvalue);
		}






		///////////////////////
		// calc missing values:
		if (m_pArrow->m_data["txtSectionaldensity"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtShaftdia"].toMap().value(
				"value").toDouble() > 0.0
				&& m_pArrow->m_data["txtMass"].toMap().value("value").toDouble()
						> 0.0) {
			double dia;
			double mass;
			double sd;
			this->get_SI_value(dia, m_pArrow->m_data["txtShaftdia"].toMap());
			this->get_SI_value(mass, m_pArrow->m_data["txtMass"].toMap());
			sd = mass / (dia * dia);
			this->set_value_from_SI("txtSectionaldensity",sd);
			m_pArrow->setValue("txtSectionaldensity/status", DlgArrowModel::calculated);
		}

		if (m_pArrow->m_data["txtBallisticcoefficient"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtFF_Frontal"].toMap().value(
				"value").toDouble() > 0.0
				&& m_pArrow->m_data["txtSectionaldensity"].toMap().value(
				"value").toDouble() > 0.0 ) {

			double formfactor;
			double sd;
			double bc;
			this->get_SI_value(sd, m_pArrow->m_data["txtSectionaldensity"].toMap());
			this->get_SI_value(formfactor, m_pArrow->m_data["txtFF_Frontal"].toMap());

			m_pControler->m_unitconverter.convert_from_SI(sd, "pound_per_square_inch");
			bc = sd / formfactor;

			m_pArrow->setValue("txtBallisticcoefficient/value", QString::number(bc));
			m_pArrow->setValue("txtBallisticcoefficient/status", DlgArrowModel::calculated);
		}

		if (m_pArrow->m_data["txtShaftdia"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtSectionaldensity"].toMap().value(
				"value").toDouble() > 0.0
				&& m_pArrow->m_data["txtMass"].toMap().value("value").toDouble()
						> 0.0) {
			double dia;
			double mass;
			double sd;
			this->get_SI_value(sd, m_pArrow->m_data["txtSectionaldensity"].toMap());
			this->get_SI_value(mass, m_pArrow->m_data["txtMass"].toMap());

			dia = sqrt(mass / sd );
			this->set_value_from_SI("txtShaftdia",dia);
			m_pArrow->setValue("txtShaftdia/status", DlgArrowModel::calculated);
		}

		if (m_pArrow->m_data["txtMass"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtSectionaldensity"].toMap().value(
				"value").toDouble() > 0.0
				&& m_pArrow->m_data["txtShaftdia"].toMap().value("value").toDouble()
						> 0.0) {
			double dia;
			double mass;
			double sd;
			this->get_SI_value(sd, m_pArrow->m_data["txtSectionaldensity"].toMap());
			this->get_SI_value(dia, m_pArrow->m_data["txtShaftdia"].toMap());

			mass = sd * dia * dia;
			this->set_value_from_SI("txtMass",mass);
			m_pArrow->setValue("txtMass/status", DlgArrowModel::calculated);
		}

		if (m_pArrow->m_data["txtFF_Frontal"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtSectionaldensity"].toMap().value(
				"value").toDouble() > 0.0
				&& m_pArrow->m_data["txtBallisticcoefficient"].toMap().value("value").toDouble()
						> 0.0) {
			double bc;
			double formfactor;
			double sd;
			bc =  m_pArrow->m_data["txtBallisticcoefficient"].toMap().value("value").toDouble();
			this->get_SI_value(sd, m_pArrow->m_data["txtSectionaldensity"].toMap());
			m_pControler->m_unitconverter.convert_from_SI(sd, "pound_per_square_inch");
			formfactor = sd / bc;
			m_pArrow->setValue("txtFF_Frontal/value",formfactor);
			m_pArrow->setValue("txtFF_Frontal/status", DlgArrowModel::calculated);
		}

		////////////////////////////////////////
		// calc the values for the "required Tab":

		if (m_pArrow->m_data["txtAreaFrontal"].toMap()["status"].toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtShaftdia"].toMap()["value"].toDouble()
						> 0.0) {
			double dia;
			this->get_SI_value(dia, m_pArrow->m_data["txtShaftdia"].toMap());
			double d = dia * dia * utility::PI / 4.0;
			this->set_value_from_SI("txtAreaFrontal", d);
			m_pArrow->setValue("txtAreaFrontal/status", DlgArrowModel::calculated);


		}
		if (m_pArrow->m_data["txtAreaCrossSection"].toMap()["status"].toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtShaftdia"].toMap()["value"].toDouble()
						> 0.0
				) {

			double dia;
			this->get_SI_value(dia, m_pArrow->m_data["txtShaftdia"].toMap());
			double d = dia * dia * utility::PI / 4.0;
			this->set_value_from_SI("txtAreaCrossSection", d);
			m_pArrow->setValue("txtAreaCrossSection/status", DlgArrowModel::calculated);


		}
		if (m_pArrow->m_data["txtCenterOfPresure"].toMap().value("status").toInt()
				!= DlgArrowModel::modified_by_user
				&& m_pArrow->m_data["txtCenterOfPresure"].toMap()["value"].toString().length()
						< 1) {
			m_pArrow->setValue("txtCenterOfPresure/value",  QString::number(0.0));
			m_pArrow->setValue("txtCenterOfPresure/status",  DlgArrowModel::calculated);
		}


}

void DlgArrowTabSimplified::addView(DlgArrowModel *dlg) {
	this->m_pControler = dlg;

	UnitConverter unitconv = dlg->m_unitconverter;
	QList<Unit> list = unitconv.get_units("SI_metre");
	for (int i = 0; i < list.size(); i++) {
		ui.cboShaftdia->addItem(list.at(i).m_name, list.at(i).m_type_id);
	}

	list = unitconv.get_units("SI_kilogram");
	for (int i = 0; i < list.size(); i++) {
		ui.cboMass->addItem(list.at(i).m_name, list.at(i).m_type_id);

	}

	list = unitconv.get_units("SI_kilogram_per_square_metre");
	for (int i = 0; i < list.size(); i++) {
		ui.cboSectionaldensity->addItem(list.at(i).m_name, list.at(i).m_type_id);

	}



	QPixmap *image = new QPixmap(":/images/arrowmeasures_simple.png");
	ui.lblImage->setPixmap(*image);

}

void DlgArrowTabSimplified::on_txtShaftdia_editingFinished() {
	if (ui.txtShaftdia->text()
			== m_pArrow->m_data["txtShaftdia"].toMap()["value"])
		return;
	if (ui.txtShaftdia->text().length() <= 0) {
		m_pArrow->setValue("txtShaftdia/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtShaftdia/value",  "");
	} else {
		m_pArrow->setValue("txtShaftdia/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtShaftdia/value",  ui.txtShaftdia->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);
}

void DlgArrowTabSimplified::on_txtMass_editingFinished() {
	if (ui.txtMass->text() == m_pArrow->m_data["txtMass"].toMap()["value"])
		return;
	if (ui.txtMass->text().length() <= 0) {
		m_pArrow->setValue("txtMass/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtMass/value",  "");
	} else {
		m_pArrow->setValue("txtMass/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtMass/value",  ui.txtMass->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabSimplified::on_txtFF_Frontal_editingFinished() {
	if (ui.txtFF_Frontal->text() == m_pArrow->m_data["txtFF_Frontal"].toMap()["value"])
		return;
	if (ui.txtFF_Frontal->text().length() <= 0) {
		m_pArrow->setValue("txtFF_Frontal/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtFF_Frontal/value",  "");
	} else {
		m_pArrow->setValue("txtFF_Frontal/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtFF_Frontal/value",  ui.txtFF_Frontal->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabSimplified::on_txtSectionaldensity_editingFinished() {
	if (ui.txtSectionaldensity->text() == m_pArrow->m_data["txtSectionaldensity"].toMap()["value"])
		return;
	if (ui.txtSectionaldensity->text().length() <= 0) {
		m_pArrow->setValue("txtSectionaldensity/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtSectionaldensity/value",  "");
	} else {
		m_pArrow->setValue("txtSectionaldensity/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtSectionaldensity/value",  ui.txtSectionaldensity->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabSimplified::on_txtBallisticcoefficient_editingFinished() {
	if (ui.txtBallisticcoefficient->text() == m_pArrow->m_data["txtBallisticcoefficient"].toMap()["value"])
		return;
	if (ui.txtBallisticcoefficient->text().length() <= 0) {
		m_pArrow->setValue("txtBallisticcoefficient/status",  DlgArrowModel::defaultvalue);
		m_pArrow->setValue("txtBallisticcoefficient/value",  "");
	} else {
		m_pArrow->setValue("txtBallisticcoefficient/status",  DlgArrowModel::modified_by_user);
		m_pArrow->setValue("txtBallisticcoefficient/value",  ui.txtBallisticcoefficient->text());
	}
	this->m_pControler->slotUpdateAllViews(NULL);

}
void DlgArrowTabSimplified::on_cboShaftdia_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtShaftdia"))
		return;
	unit_changed("txtShaftdia", ui.cboShaftdia, index);

}

void DlgArrowTabSimplified::on_cboMass_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtMass"))
		return;
	unit_changed("txtMass", ui.cboMass, index);

}

void DlgArrowTabSimplified::on_cboSectionaldensity_currentIndexChanged(int index) {
	if (m_pArrow == NULL)
		return;
	if (!m_pArrow->m_data.contains("txtSectionaldensity"))
		return;
	unit_changed("txtSectionaldensity", ui.cboSectionaldensity, index);

}

///////////////////////////////////////////////////////////

bool DlgArrowTabSimplified::get_unit_id(QString &unit_id, int index,
		QComboBox *combo) {
	if (index < 0)
		return false;
	unit_id = combo->itemData(index).toString();
	return true;
}
bool DlgArrowTabSimplified::set_unit_id(QString unit_id, QComboBox *combo) {
	QVariant var(unit_id);
	int index = combo->findData(var);
	//qDebug(var.toByteArray());
	//qDebug(QString::number(index).toAscii());
	combo->setCurrentIndex(index);
	return true;

}
bool DlgArrowTabSimplified::get_SI_value(double & value, const QMap<QString,
		QVariant> &map) {
	value = map["value"].toDouble();
	QString unit_id = map["unit"].toString();
	return this->m_pControler->m_unitconverter.convert_to_SI(value, unit_id);
}
bool DlgArrowTabSimplified::set_value_from_SI(QMap<QString, QVariant> &map,
		double value) {
	m_pControler->m_unitconverter.convert_from_SI(value, map["unit"].toString());// if conversion fails, because of an unknown unit, the SI-value is written
	map["value"] = QString::number(value);
	return true;

}
bool DlgArrowTabSimplified::set_value_from_SI(QString path_to_map,
		double value) {
	QString unit_id = m_pArrow->getValue(path_to_map + "/unit").toString();
	m_pControler->m_unitconverter.convert_from_SI(value, unit_id);// if conversion fails, because of an unknown unit, the SI-value is written
	m_pArrow->setValue(path_to_map + "/value",  QString::number(value));
	return true;

}
void DlgArrowTabSimplified::unit_changed(QMap<QString, QVariant> &map,
		QComboBox *combo, int index) {
	QString unit_id;
	if (!get_unit_id(unit_id, index, combo))
		return;
	QString prev_unit_id = map["unit"].toString();
	map["unit"] = unit_id;
	if (map["value"].toString().length() > 0) {
		double value = map["value"].toDouble();
		m_pControler->m_unitconverter.convert(value, unit_id, prev_unit_id);
		map["value"] = QString::number(value);
	}
	this->m_pControler->slotUpdateAllViews(NULL);
}
void DlgArrowTabSimplified::unit_changed(QString path_to_map,
		QComboBox *combo, int index) {
	QString unit_id;
	if (!get_unit_id(unit_id, index, combo))
		return;
	QString prev_unit_id = m_pArrow->getValue(path_to_map +"/unit").toString();
	m_pArrow->setValue(path_to_map + "/unit", unit_id);
	QString old_val = m_pArrow->getValue(path_to_map + "/value").toString();
	if (old_val.length() > 0) {
		double value = old_val.toDouble();
		m_pControler->m_unitconverter.convert(value, unit_id, prev_unit_id);
		m_pArrow->setValue(path_to_map + "/value",  QString::number(value) );
	}
	this->m_pControler->slotUpdateAllViews(NULL);
}
