/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 *  Created on: 30.4.2010
 */

#ifndef DLGARROWTABSIMPLIFIED_H
#define DLGARROWTABSIMPLIFIED_H


#include <QtGui/QWidget>
#include "ui_dlgarrowtabsimplified.h"
#include "DlgArrowModel.h"
#include "DlgArrowTabUpdateable.h"

class DlgArrowModel;

class DlgArrowTabSimplified : public QWidget, public DlgArrowTabUpdateable
{
    Q_OBJECT

public:
    DlgArrowTabSimplified(QWidget *parent = 0);
    ~DlgArrowTabSimplified();

    void update(CPfeil *arrow);
	void calc(CPfeil *arrow);
	void addView(DlgArrowModel *dlg);

	bool calc_fletchesarea(double &area, const double length);
	bool get_unit_id(QString &unit_id, int index, QComboBox *combo);
	bool set_unit_id(QString unit_id, QComboBox *combo);
	bool get_SI_value(double & value, const QMap<QString, QVariant> &map);
	bool set_value_from_SI(QMap<QString, QVariant> &map, double value);
	bool set_value_from_SI(QString path_to_map , double value);
	void unit_changed(QMap<QString, QVariant> &map, QComboBox *combo, int index);
	void unit_changed(QString path_to_map, QComboBox *combo, int index);

public slots:
	void on_txtShaftdia_editingFinished();
	void on_txtMass_editingFinished();
	void on_txtFF_Frontal_editingFinished();
	void on_txtSectionaldensity_editingFinished();
	void on_txtBallisticcoefficient_editingFinished();

	void on_cboShaftdia_currentIndexChanged(int index);
	void on_cboMass_currentIndexChanged(int index);
	void on_cboSectionaldensity_currentIndexChanged(int index);


private:
	CPfeil *m_pArrow;
    Ui::DlgArrowTabSimplifiedClass ui;
};

#endif // DLGARROWTABSIMPLIFIED_H
