/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * main.cpp
 *  Created on: 01.11.2009
 */
#include <iostream>
#include <ballistic/ballistic.h>
#include <map>
#include <QString>
#include <QMap>
#include <src/UnitConverter.h>
#include <QDebug>
//#include <src/Armbrust.h>



/**
set multiplot;
set autoscale;
set datafile commentschars "#/t"

set size 1,0.5;;

set origin 0.0, 0.0;

set xzeroaxis;
set grid;
set ylabel '[rad]';
plot '/home/herbert/out.csv' using 2:13 title 'phi.z' with lines;

set origin 0.0, 0.5;
set ylabel '[rad/s]';
plot '/home/herbert/out.csv' using 2:16 title 'omega.z' with lines;
unset multiplot;

#######################################
# expecting 'unique', 'frequency', 'cumulative', 'kdensity', 'acsplines', 'csplines', 'bezier' or 'sbezier'


set xlabel 'range [m]'
set ylabel 'wind drift [m]'

plot 'flugbahn_4cm.csv' using 1:2 with lines title '4cm vanes',\
 'flugbahn_7cm.csv' using 1:2 with lines  title '7cm vanes'


#Geglättete Kurve mit cumulative
plot 'flugbahn_4cm.csv' using 1:2 with lines  smooth bezier title '4cm vanes',\
 'flugbahn_7cm.csv' using 1:2 with lines  smooth  bezier title '7cm vanes'


*/
int main(int argc, char *argv[])
{

	//CArmbrust armb;


	arw::arrow a;
	// 4cm Befiederung:
	a.A_frontal = 0.008*0.008 * arw::utility::PI / 4.0;
	a.A_frontal = 5.98746e-05;
	a.A_cross = 0.008* 0.5 + 0.01 * 0.01 * 5.0;
	a.A_cross = 0.00479115;
	a.cp = -0.0557993;
	a.ff_cross = 1.0;
	a.ff_frontal = 1.0;
	a.m = 0.0239946;
	a.J = 0.000796582;

	// 7cm Befiederung:
	a.A_frontal = 5.98746e-05;
	a.A_cross = 0.00500905;
	a.cp = -0.0630392;
	a.m = 0.0241783;
	a.J = 0.000825222;



	arw::flightparam fp;
	arw::Ballistic::flightparam_init(fp, a);
	fp.wind.z = 5.0;// m/s

    arw::flight_snapshot snapshot, s;
    snapshot.t = 0.0;
    snapshot.s.x = 0.0;
    snapshot.s.y = 0.0;
    snapshot.s.z = 0.0;
    snapshot.v.x = 70.0;
    snapshot.v.y = 0.0;
    snapshot.v.z = 0.0;
    // Pfeil zeigt genau in Flugrichtung:
    snapshot.phi.x = 0.0;
    snapshot.phi.y = 0.0;
    snapshot.phi.z = 0.0;
    // noch keine Drehungen:
    snapshot.omega.x = 0.0;
    snapshot.omega.y = 0.0;
    snapshot.omega.z = 0.0;


    arw::Ballistic b(fp);

    arw::flight_snapshot begin_fs;
    arw::flight_snapshot end_fs;
    int ret = b.calc_max_range(begin_fs, end_fs, 80.0);

    //return 0;
    s = snapshot;
    std::cout << "Entfernung[m]" << '\t' << "Drift[m]" << std::endl;
    //b.print_flight_snapshot_header();
    for(int i=0; i< 20000; i++){
    	b.do_euler_step(&s, 0.001);
    	std::cout << s.s.x << '\t' << s.s.z << std::endl;
    	//b.print_flight_snapshot(s);
    	if(s.s.x > 140.0)
    		break;
    }
    //std::cout << "Wert" << std::endl;
    double value;
    Unit unit;
    UnitConverter uc;
    uc.m_system = Unit::english;
	uc.convert_to_current_system(value, unit, 25.4, "millimetre_per_metre");
	//qDebug() << "Wert:" << value << "Einheit="<< unit.m_type_id;


	return 0;
}

